\begin{exercise}
Use the inference rules defining the \FOMEGASUB{} subtype relation to
decide how the <<fomega>> implementation will respond to the following
assertions.
\ifsolution\else
\verbatimfile{subchecks.f}
\fi
\end{exercise}

\ifsolution
>> reset latex;
set echo;
%%% use subchecks;
%%% set latex;
\fi

\begin{exercise}
In Exercise~\ref{ex:packing}, we found four different values for <<T>>
such that  
\begin{verbatim}
    <Int, {a=5,b=7}> : T 
\end{verbatim}
is well typed.  Using subtyping and bounded existential quantifiers,
how many more can you find?  
\end{exercise}

\ifsolution
\noindent Here are a few:
> <Int, {a=5,b=7}> : Some(A){|a:A|};
> <Int, {a=5,b=7}> : Some(A){|a:A,b:Top(*)|};
> <Int, {a=5,b=7}> : Some(A)Top(*);
> <Int, {a=5,b=7}> : Some(A<Int){|a:A,b:A|};
> <Int, {a=5,b=7}> : Some(A<Int){|a:A|};
\fi

