signature TYPHELPERCOMMON = sig

structure Typ: TYP
structure TEnv: TENV
structure Globals: GLOBALS
sharing Typ.Globals = Globals
    and TEnv.Typ = Typ
include GLOBALS

type PreTyp

val debruijnify: TEnv.T -> PreTyp -> Typ.T

val prt: TEnv.T -> Typ.T -> unit
val prt_outer: TEnv.T -> Typ.T -> unit
val prt_nested: TEnv.T -> Typ.T -> unit

val prt_tenv: TEnv.T -> unit

end




